/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.wahlausschuss.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="WAHLAUSSCHUSS_ENTSCHAEDIGUNG.UK",
     query="SELECT o FROM WahlausschussEntschaedigung o WHERE "

                         + "o"
                +".wahlausschussrolle"
              +" = ?1"

             +" AND "         + "o"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?2"

             +" AND "         + "o"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?3"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?4"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?5"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?6"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="WAHLAUSSCHUSS_ENTSCHAEDIGUNG.WahlAndRolle",
     query="SELECT o FROM WahlausschussEntschaedigung o WHERE o.wahl = ?1 AND o.wahlausschussrolle = ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLAUSSCHUSS_ENTSCHAEDIGUNG.Wahl",
     query="SELECT o FROM WahlausschussEntschaedigung o WHERE o.wahl = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "WAHLAUSSCHUSS_ENTSCHAEDIGUNG")
// @javax.persistence.IdClass(WahlausschussEntschaedigungPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class WahlausschussEntschaedigung
extends AbstractWahlausschussEntschaedigung
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public WahlausschussEntschaedigung() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public WahlausschussEntschaedigung(WahlausschussEntschaedigung original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "wahlausschuss_entschaedigun_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "WahlausschussEntschaedigung")
    @javax.persistence.TableGenerator(name = "WahlausschussEntschaedigung", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "WahlausschussEntschaedigung", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient WahlausschussEntschaedigungPK pkCache;

  @Override
  public WahlausschussEntschaedigungPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new WahlausschussEntschaedigungPK(getId());
    }

    return pkCache;
  }

  public static <E extends WahlausschussEntschaedigung> java.util.Map<WahlausschussEntschaedigungPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<WahlausschussEntschaedigungPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends WahlausschussEntschaedigung> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedBetrag = false;
          hasChangedWaehrungAlsIsoCode = false;
          hasChangedWahlausschussrolle = false;
  
      hasChangedWahl = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
      @javax.persistence.Column(name = "BETRAG", nullable = WahlausschussEntschaedigungConstants.BETRAG_NULLABLE, precision=WahlausschussEntschaedigungConstants.BETRAG_PRECISION, scale=WahlausschussEntschaedigungConstants.BETRAG_SCALE)
            
  protected java.math.BigDecimal betrag =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBetrag = false;

  public boolean hasChangedBetrag(){
    return hasChangedBetrag;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBetrag = false;
     @javax.persistence.Transient
     private transient java.math.BigDecimal wertNachLadenBetrag;
  
  /**
   * 
   *
   * getter for WAHLAUSSCHUSS_ENTSCHAEDIGUNG.BETRAG
   */
    @Override   public  java.math.BigDecimal getBetrag() {
        return betrag;
      }

  /**
   * 
   *
   * setter for WAHLAUSSCHUSS_ENTSCHAEDIGUNG.BETRAG
   *
   * @param betrag
   */
  @Override   public void setBetrag( java.math.BigDecimal betrag) {

       resetTkCache();
                  java.math.BigDecimal betragInternal = betrag;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.betrag
      , betragInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBetrag |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("betrag");
      }


             if (!isSeitLadenVeraendertBetrag) {
          isSeitLadenVeraendertBetrag = thisAttributChanged;
         if (isSeitLadenVeraendertBetrag){
           wertNachLadenBetrag=this.betrag;
         }
       }
      

       this.betrag = betragInternal;

         }

        
      @javax.persistence.Column(name = "WAEHRUNG", nullable = WahlausschussEntschaedigungConstants.WAEHRUNG_NULLABLE, length=WahlausschussEntschaedigungConstants.WAEHRUNG_MAX_LENGTH)
        
  protected java.lang.String waehrungAlsIsoCode =  null;

  @javax.persistence.Transient
  protected boolean hasChangedWaehrungAlsIsoCode = false;

  public boolean hasChangedWaehrungAlsIsoCode(){
    return hasChangedWaehrungAlsIsoCode;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertWaehrungAlsIsoCode = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenWaehrungAlsIsoCode;
  
  /**
   * 
   *
   * getter for WAHLAUSSCHUSS_ENTSCHAEDIGUNG.WAEHRUNG
   */
    @Override   public  java.lang.String getWaehrungAlsIsoCode() {
        return waehrungAlsIsoCode;
      }

  /**
   * 
   *
   * setter for WAHLAUSSCHUSS_ENTSCHAEDIGUNG.WAEHRUNG
   *
   * @param waehrungAlsIsoCode
   */
  @Override   public void setWaehrungAlsIsoCode( java.lang.String waehrungAlsIsoCode) {

       resetTkCache();
                  
                          java.lang.String waehrungAlsIsoCodeInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(waehrungAlsIsoCode, WahlausschussEntschaedigungConstants.WAEHRUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.waehrungAlsIsoCode
      , waehrungAlsIsoCodeInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedWaehrungAlsIsoCode |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("waehrungAlsIsoCode");
      }


             if (!isSeitLadenVeraendertWaehrungAlsIsoCode) {
          isSeitLadenVeraendertWaehrungAlsIsoCode = thisAttributChanged;
         if (isSeitLadenVeraendertWaehrungAlsIsoCode){
           wertNachLadenWaehrungAlsIsoCode=this.waehrungAlsIsoCode;
         }
       }
      

       this.waehrungAlsIsoCode = waehrungAlsIsoCodeInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "WAHLAUSSCHUSSROLLE", nullable = WahlausschussEntschaedigungConstants.WAHLAUSSCHUSSROLLE_NULLABLE)
    
  protected de.ivu.elect.business.wahlausschuss.entity.Wahlausschussrolle wahlausschussrolle =  null;

  @javax.persistence.Transient
  protected boolean hasChangedWahlausschussrolle = false;

  public boolean hasChangedWahlausschussrolle(){
    return hasChangedWahlausschussrolle;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertWahlausschussrolle = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.wahlausschuss.entity.Wahlausschussrolle wertNachLadenWahlausschussrolle;
  
  /**
   * 
   *
   * getter for WAHLAUSSCHUSS_ENTSCHAEDIGUNG.WAHLAUSSCHUSSROLLE
   */
    @Override   public  de.ivu.elect.business.wahlausschuss.entity.Wahlausschussrolle getWahlausschussrolle() {
        return wahlausschussrolle;
      }

  /**
   * 
   *
   * setter for WAHLAUSSCHUSS_ENTSCHAEDIGUNG.WAHLAUSSCHUSSROLLE
   *
   * @param wahlausschussrolle
   */
  @Override   public void setWahlausschussrolle( de.ivu.elect.business.wahlausschuss.entity.Wahlausschussrolle wahlausschussrolle) {

       resetTkCache();
                  de.ivu.elect.business.wahlausschuss.entity.Wahlausschussrolle wahlausschussrolleInternal = wahlausschussrolle;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahlausschussrolle
      , wahlausschussrolleInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedWahlausschussrolle |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("wahlausschussrolle");
      }


             if (!isSeitLadenVeraendertWahlausschussrolle) {
          isSeitLadenVeraendertWahlausschussrolle = thisAttributChanged;
         if (isSeitLadenVeraendertWahlausschussrolle){
           wertNachLadenWahlausschussrolle=this.wahlausschussrolle;
         }
       }
      

       this.wahlausschussrolle = wahlausschussrolleInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Wahl
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHL_ID", referencedColumnName="WAHL_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahl wahl;

  /**
   * 
   */
  @Override
  public void setWahl( de.ivu.elect.business.wahl.entity.Wahl wahl){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahl
    , wahl);

    attributeChanged |= thisAttributChanged;

    hasChangedWahl |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahl");
    }

    this.wahl = wahl;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.wahl.entity.Wahl getWahl(){
    return this.wahl;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahl = false;

  public boolean hasChangedWahl(){
    return hasChangedWahl;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("WahlausschussEntschaedigung:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(WahlausschussEntschaedigung other){
                             other.betrag = this.betrag;
                                other.waehrungAlsIsoCode = this.waehrungAlsIsoCode;
                                other.wahlausschussrolle = this.wahlausschussrolle;
           
  other.setWahl(this.getWahl());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(WahlausschussEntschaedigung.class)){
        copyEntityAttributesUsingSetter((WahlausschussEntschaedigung) other.castTo(WahlausschussEntschaedigung.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von WahlausschussEntschaedigung: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(WahlausschussEntschaedigung other){
               other.setBetrag(this.betrag);
                  other.setWaehrungAlsIsoCode(this.waehrungAlsIsoCode);
                  other.setWahlausschussrolle(this.wahlausschussrolle);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(WahlausschussEntschaedigung other){
                       if (hasChangedBetrag) {
        other.setBetrag(this.betrag);
      }
                             if (hasChangedWaehrungAlsIsoCode) {
        other.setWaehrungAlsIsoCode(this.waehrungAlsIsoCode);
      }
                             if (hasChangedWahlausschussrolle) {
        other.setWahlausschussrolle(this.wahlausschussrolle);
      }
             }





    @javax.persistence.Transient
    private transient WahlausschussEntschaedigungTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public WahlausschussEntschaedigungTK getWahlausschussEntschaedigungTK(){
    if (tkCache==null) {
    tkCache = new WahlausschussEntschaedigungTK(

getWahlausschussrolle()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getWahlausschussEntschaedigungTK();
    }

  @Override
  public WahlausschussEntschaedigungUK getUk(){
    return getWahlausschussEntschaedigungUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return WahlausschussEntschaedigung.class;
  }

public WahlausschussEntschaedigungUK getWahlausschussEntschaedigungUK(){

   return  new WahlausschussEntschaedigungUK(

getWahlausschussrolle()
,     getWahl()==null?null:getWahl().getWahlUK()


  );
}

  @javax.persistence.Transient
  private transient WahlausschussEntschaedigungProperties properties;

  public WahlausschussEntschaedigungProperties getProperties(){
    if (properties == null) {
      properties = new WahlausschussEntschaedigungProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public WahlausschussEntschaedigungProperties getWahlausschussEntschaedigungProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return WahlausschussEntschaedigungConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(WahlausschussEntschaedigungConstants.MESSAGE_KEY_BETRAG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlausschussEntschaedigungConstants.MESSAGE_KEY_BETRAG_EINZAHL);

        betrag =
                        vorher.getAttributTyp().getValueAsBigDecimal(vorher.getWertVorher());
                  }

            
      if (werteVorher.containsKey(WahlausschussEntschaedigungConstants.MESSAGE_KEY_WAEHRUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlausschussEntschaedigungConstants.MESSAGE_KEY_WAEHRUNG_EINZAHL);

        waehrungAlsIsoCode =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WahlausschussEntschaedigungConstants.MESSAGE_KEY_WAHLAUSSCHUSSROLLE_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlausschussEntschaedigungConstants.MESSAGE_KEY_WAHLAUSSCHUSSROLLE_EINZAHL);

        wahlausschussrolle =
     (de.ivu.elect.business.wahlausschuss.entity.Wahlausschussrolle) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertBetrag) {
      result.put(WahlausschussEntschaedigungConstants.MESSAGE_KEY_BETRAG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.BIG_DECIMAL
                            , wertNachLadenBetrag , betrag));
    }
                            if (isSeitLadenVeraendertWaehrungAlsIsoCode) {
      result.put(WahlausschussEntschaedigungConstants.MESSAGE_KEY_WAEHRUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenWaehrungAlsIsoCode , waehrungAlsIsoCode));
    }
                            if (isSeitLadenVeraendertWahlausschussrolle) {
      result.put(WahlausschussEntschaedigungConstants.MESSAGE_KEY_WAHLAUSSCHUSSROLLE_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenWahlausschussrolle , wahlausschussrolle));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertBetrag = false;
      wertNachLadenBetrag = null;
                          isSeitLadenVeraendertWaehrungAlsIsoCode = false;
      wertNachLadenWaehrungAlsIsoCode = null;
                          isSeitLadenVeraendertWahlausschussrolle = false;
      wertNachLadenWahlausschussrolle = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "WAHLAUSSCHUSS_ENTSCHAEDIGUNG";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "WahlausschussEntschaedigung";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(betrag, this, WahlausschussEntschaedigungConstants.MESSAGE_KEY_BETRAG_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(WahlausschussEntschaedigungConstants.BETRAG_MAX_VALUE, WahlausschussEntschaedigungConstants.BETRAG_MIN_VALUE, betrag, this, WahlausschussEntschaedigungConstants.MESSAGE_KEY_BETRAG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(waehrungAlsIsoCode, this, WahlausschussEntschaedigungConstants.MESSAGE_KEY_WAEHRUNG_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(WahlausschussEntschaedigungConstants.WAEHRUNG_MAX_LENGTH , 1 ,  waehrungAlsIsoCode, this, WahlausschussEntschaedigungConstants.MESSAGE_KEY_WAEHRUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(wahlausschussrolle, this, WahlausschussEntschaedigungConstants.MESSAGE_KEY_WAHLAUSSCHUSSROLLE_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
